/**
 * Copyright (c) 2019 Nexi Payments S.p.A.
 *
 * @author      iPlusService S.r.l.
 * @category    Payment Module
 * @package     Nexi XPay
 * @version     6.0.0
 * @copyright   Copyright (c) 2019 Nexi Payments S.p.A. (https://ecommerce.nexi.it)
 * @license     GNU General Public License v3.0
 */

(function ($) {
    jQuery(document).ready(function () {

        var renderPreview = function (element) {
            var styles = ["font-family", "font-size", "font-style", "font-variant", "letter-spacing", "border-color", "placeholder-color", "color"];

            if (element.hasClass('build_style')) {
                for (var i = 0; i < styles.length; i++) {
                    if (element.hasClass(styles[i])) {
                        if (styles[i] === 'border-color') {
                            $('.stylePreview .content-anteprima div.Bricks').css(styles[i], element.val());
                        } else if (styles[i] === 'placeholder-color') {
                            $('#dynamicStyle').html('.stylePreview .content-anteprima .Bricks input::placeholder { color: ' + element.val() + '}');
                        } else {
                            $('.stylePreview .content-anteprima .Bricks input').css(styles[i], element.val());
                        }
                        break;
                    }
                }
            }
        };

        $('input.build_style, select.build_style').each(function (index, element) {
            renderPreview($(element));
        });

        $('select.build_style').on('change', function () {
            renderPreview($(this));
        });

        $('input.build_style').on('focusout', function () {
            renderPreview($(this));
        });

        $('.categories-select2').select2({
            closeOnSelect: false,
            scrollAfterSelect: true,
            templateSelection: formatState
        });

        function formatState(state) {
            var temp = state.text.split('->');

            return temp[temp.length - 1];
        }

        var checkCategoriesSelectVisibility = function () {
            if ($('.check-mode-categories').val() === 'selected_categories') {
                $('.categories-select2').attr("disabled", false);
            } else {
                $('.categories-select2').attr("disabled", true);
            }
        };

        checkCategoriesSelectVisibility();

        $('.check-mode-categories').change(function () {
            checkCategoriesSelectVisibility();
        });

        jQuery("#xpay_account_form_btn").on("click", function () {
            jQuery("#xpay_account_form_btn").attr("disabled", true);

            var api_url = jQuery("#xpay_account_form_api_url").val();
            var amount = jQuery("#xpay_account_account_input").val();
            var success_message = jQuery("#xpay_account_form_success_message").val();

            if (jQuery.isNumeric(amount) && amount > 0) {
                jQuery("#xpay_account_account_input").attr("disabled", true);

                var domanda = confirm(
                        jQuery("#xpay_account_form_question").val() +
                        " " +
                        amount +
                        " " +
                        jQuery("#xpay_account_form_currency_label").val() +
                        " ?"
                        );
                if (domanda === true) {
                    $('html, body').css("cursor", "wait");

                    jQuery.ajax({
                        type: "POST",
                        dataType: "json",
                        url: api_url,
                        beforeSend: function (xhr) {
                            xhr.setRequestHeader("X-WP-Nonce", wpApiSettings.nonce);
                        },
                        data: {
                            amount: amount
                        },
                        success: function (json) {
                            $('html, body').css("cursor", "default");

                            alert(success_message);
                            window.location.reload();
                        },
                        error: function (xhr, textStatus, err) {
                            $('html, body').css("cursor", "default");

                            var data = xhr.responseJSON;
                            alert(data.message);
                            window.location.reload();
                        }
                    });
                }
            } else {
                alert("Importo non valido!");
                jQuery("#xpay_account_account_input").val("");
                jQuery("#xpay_account_account_input").focus();
                jQuery("#xpay_account_form_btn").attr("disabled", false);
            }
        });
    });
})(jQuery);
